package be.iminds.ilabt.jfed.highlevel.tasks;

import be.iminds.ilabt.jfed.fedmon.webapi.service.json.Server;
import be.iminds.ilabt.jfed.highlevel.controller.Task;
import be.iminds.ilabt.jfed.highlevel.controller.TaskExecution;
import be.iminds.ilabt.jfed.highlevel.model.Slice;
import be.iminds.ilabt.jfed.highlevel.util.AggregateManagerWrapperFactory;
import be.iminds.ilabt.jfed.lowlevel.connection.JFedException;
import be.iminds.ilabt.jfed.lowlevel.api_wrapper.AggregateManagerWrapper;

import javax.annotation.Nonnull;
import java.util.Collections;
import java.util.List;

public class UnshareLanTask extends PoaTask {
    @Nonnull private final String lanClientId;
    @Nonnull private final String sharedLanName;

    public UnshareLanTask(@Nonnull Slice slice,
                          @Nonnull Server auth,
                          @Nonnull String lanClientId,
                          @Nonnull String sharedLanName,
                          @Nonnull AggregateManagerWrapperFactory aggregateManagerWrapperFactory,
                          @Nonnull HighLevelTaskFactory highLevelTaskFactory) {
        super("Unshare Lan " + lanClientId + " as " + sharedLanName,
                slice, auth, slice.getUrn(),
                aggregateManagerWrapperFactory, highLevelTaskFactory);
        this.lanClientId = lanClientId;
        this.sharedLanName = sharedLanName;
    }

    @Override
    public void doPoaAction(@Nonnull AggregateManagerWrapper amWrapper) throws JFedException {
        amWrapper.unshareLan(poaTarget, slice.getCredentials(), lanClientId, sharedLanName);
    }
}
